=== debian/changelog ===
xca (2.5.0-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:36:46 +1100

xca (2.5.0-1ubuntu1) noble; urgency=medium

  * Replace libqt5sql5 with libqt5sql5t64 in Build-Depends.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 25 Mar 2024 14:45:02 +1300

xca (2.5.0-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:31:41 +0000

xca (2.5.0-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:17:12 +0000

xca (2.5.0-1) unstable; urgency=medium

  * New upstream release (2.5.0)
  * Upstream now uses CMake for builds, which invalidates multiple quilt 
    patches.
  * Dropped patches from d/patches:
    - xca-240-ossl3.patch: Already included in 2.5.0
    - 0001-Remove-misc-Info.plist-in-clean-target.patch: Obsolete due 
      to CMake move.
    - 0002-pkg-config-remove-hardcoding.patch: Obsolete due to
      CMake move.
  * d/control: Update build dependencies because we use CMake; use XCA
    upstream git home for build-dependencies list.
  * d/rules: Numerous changes to adapt for CMake build environment 
    as changed by Upstream.

 -- Thomas Ward <teward@ubuntu.com>  Wed, 11 Oct 2023 14:52:56 -0400
