=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT=qt5
export CMAKE_INSTALL_PREFIX=/usr

%:
	dh $@

override_dh_auto_configure:
	STRIP=true dh_auto_configure

override_dh_auto_install:
	destdir=$(CURDIR)/debian/xca dh_auto_install

override_dh_auto_build:
	dh_auto_build -- all

ORIG=${DEB_SOURCE}_${DEB_VERSION_UPSTREAM}

get-orig-source:
	git archive --format=tar upstream/${DEB_VERSION_UPSTREAM} --prefix=${ORIG}/ | gzip -9 > ../${ORIG}.orig.tar.gz
