## xca 2.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,14 +15,46 @@
 list(JOIN OS_DATA_LIST " -- " OS_DATA)
 message(STATUS ${OS_DATA})
 
+string(REGEX MATCH  "([0-9]+\.[0-9]+\.[0-9]+)" OSX_SDK_MINIMUM
+	${CMAKE_OSX_DEPLOYMENT_TARGET} ".0.0.0")
+
 include(GNUInstallDirs)
+include(CTest)
 
 ##### Git command to tweak the version and commit hash
 include(cmake/git_version.cmake)
+file(WRITE ${PROJECT_BINARY_DIR}/PKGVERSION.txt ${PROJECT_VERSION}\n)
 
 ##### Build specifications
 
+find_program(CCACHE_EXECUTABLE ccache)
+mark_as_advanced(CCACHE_EXECUTABLE)
+if(CCACHE_EXECUTABLE)
+  if(NOT DEFINED CMAKE_CXX_COMPILER_LAUNCHER AND NOT
+                 CMAKE_CXX_COMPILER MATCHES ".*/ccache")
+    message(STATUS "Enabling ccache")
+    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE_EXECUTABLE} CACHE STRING "")
+  endif()
+endif()
+
 set(ADDRESS_SANITIZER OFF CACHE BOOL "Enable Address sanitizing")
+set(APPSTORE_COMPLIANT OFF CACHE BOOL "Create an Appstore compliant, sanboxed app")
+set(PROVISIONPROFILE "" CACHE STRING "Location of the embedded.provisionprofile")
+if (APPSTORE_COMPLIANT)
+  set(APPLE_DEVELOPER_CERT "3rd Party Mac Developer Application")
+  set(APPSTORE -appstore-compliant)
+else()
+  set(APPLE_DEVELOPER_CERT "Developer ID Application")
+endif()
+if(APPLE)
+  execute_process(COMMAND security find-identity -v
+                  ERROR_QUIET OUTPUT_VARIABLE IDCHECK)
+  string(FIND "${IDCHECK}" "${APPLE_DEVELOPER_CERT}" matchres)
+  if(matchres EQUAL -1)
+    unset(APPLE_DEVELOPER_CERT)
+  endif()
+endif()
+
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 set(CMAKE_CXX_STANDARD 17)
@@ -34,17 +66,23 @@
 set(CMAKE_AUTOUIC ON)
 add_compile_definitions(OPENSSL_SUPPRESS_DEPRECATED QT_MESSAGELOGCONTEXT)
 
+add_compile_options(-Wall -Wextra -Wno-unknown-pragmas)
 if (ADDRESS_SANITIZER)
   add_compile_options(-fsanitize=address -O1 -fno-omit-frame-pointer -g)
   set(ASAN_LIB -fsanitize=address)
 endif()
+if (CMAKE_CXX_COMPILER_ID MATCHES Clang|GNU)
+  add_compile_options(-fmacro-prefix-map=${PROJECT_SOURCE_DIR}=.)
+endif()
 
 file(GLOB UI_FILES ${CMAKE_AUTOUIC_SEARCH_PATHS}/*.ui)
 
 configure_file(local.h.in local.h)
 
 ##### Libraries and executables
-add_executable(${CMAKE_PROJECT_NAME} img/imgres.qrc ${UI_FILES} ${PROJECT_BINARY_DIR}/local.h)
+add_library(xcalib STATIC)
+add_executable(${CMAKE_PROJECT_NAME} img/imgres.qrc lib/main.cpp
+		${UI_FILES} ${PROJECT_BINARY_DIR}/local.h)
 add_executable(xcadoc ${PROJECT_BINARY_DIR}/local.h)
 
 include_directories(${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR})
@@ -71,6 +109,8 @@
 find_package(QT NAMES ${QTFIXEDVERSION} REQUIRED COMPONENTS Core)
 set(QT Qt${QT_VERSION_MAJOR})
 find_package(${QT} REQUIRED COMPONENTS Core Widgets Sql Help LinguistTools)
+find_package(${QT} QUIET COMPONENTS Test)
+
 message(STATUS "Using ${QT} with version ${QT_VERSION}")
 
 get_target_property(qmake_executable ${QT}::qmake IMPORTED_LOCATION)
@@ -80,16 +120,15 @@
   get_filename_component(OPENSSL_ROOT_DIR ${OPENSSL_INCLUDE_DIR} DIRECTORY)
 endif()
 
-target_link_libraries(${CMAKE_PROJECT_NAME}
+target_link_libraries(xcalib
 	OpenSSL::Crypto
 	${QT}::Widgets ${QT}::Core ${QT}::Sql ${QT}::Help
 	${ASAN_LIB}
 )
 target_link_libraries(xcadoc
-	OpenSSL::Crypto
-	${QT}::Widgets ${QT}::Core ${QT}::Sql ${QT}::Help
-	${ASAN_LIB}
-)
+	OpenSSL::Crypto ${QT}::Core ${ASAN_LIB}
+)
+target_link_libraries(${CMAKE_PROJECT_NAME} ${ASAN_LIB} xcalib)
 
 if (APPLE)
 
@@ -128,15 +167,18 @@
     "\n</Fragment>\n</Wix>")
 endmacro()
 
+add_custom_target(tests)
+
 ##### Sub directories
 
 add_subdirectory(lib)
 add_subdirectory(widgets)
 
+include(lang/CMakeLists.txt)
 include(misc/CMakeLists.txt)
-include(lang/CMakeLists.txt)
 include(doc/CMakeLists.txt)
 include(img/CMakeLists.txt)
+include(test/CMakeLists.txt)
 
 install(TARGETS ${CMAKE_PROJECT_NAME}
 	RESOURCE DESTINATION Resources
@@ -159,16 +201,23 @@
   find_program(MACDEPLOYQT_EXECUTABLE macdeployqt HINTS ${_qt_bin_dir})
   add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
     COMMAND ${MACDEPLOYQT_EXECUTABLE} $<TARGET_FILE_DIR:${PROJECT_NAME}>/../..
-        -always-overwrite
+        -always-overwrite ${APPSTORE}
     COMMENT "Running macdeployqt..."
   )
-  if (DEFINED ENV{APPLE_DEVELOPER_HASH})
+  if (PROVISIONPROFILE)
     add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
-      COMMAND codesign --deep --signature-size=96000 --options=runtime --timestamp
-		--entitlements ${PROJECT_SOURCE_DIR}/misc/entitlement.plist
-                --force -s "$ENV{APPLE_DEVELOPER_HASH}"
+      COMMAND cmake -E copy ${PROVISIONPROFILE}
+              $<TARGET_FILE_DIR:${PROJECT_NAME}>/../embedded.provisionprofile)
+  endif()
+  if (DEFINED APPLE_DEVELOPER_CERT)
+    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
+      COMMAND codesign --deep --signature-size=96000
+                --options=runtime --timestamp
+		--entitlements ${PROJECT_SOURCE_DIR}/misc/entitlement${APPSTORE}.plist
+		--force -s ${APPLE_DEVELOPER_CERT}
 		$<TARGET_FILE_DIR:${PROJECT_NAME}>/../..
-      COMMENT "Running codesign for $ENV{APPLE_DEVELOPER} ..."
+      COMMENT "Running codesign for ${APPLE_DEVELOPER_CERT} ..."
+      DEPENDS ${PROJECT_SOURCE_DIR}/misc/entitlement${APPSTORE}.plist
     )
   endif()
 
@@ -200,7 +249,7 @@
      ${CMAKE_BINARY_DIR}/doc/documentation.wxs
      ${CMAKE_BINARY_DIR}/misc/misc.wxs
      ${CMAKE_BINARY_DIR}/misc/dynamic.wxs
-     )
+  )
   target_link_options(${CMAKE_PROJECT_NAME} PRIVATE -mwindows -MD)
   install(DIRECTORY
 	  ${CMAKE_BINARY_DIR}/platforms
@@ -220,6 +269,10 @@
 		${OPENSSL_ROOT_DIR}/bin/libcrypto-${OPENSSL_LIBRARY_MAJOR}-x64.dll
 	  DESTINATION ${RUNTIME_DEST}
   )
+  if (OPENSSL_LIBRARY_MAJOR EQUAL 3)
+      install(FILES ${OPENSSL_ROOT_DIR}/lib/ossl-modules/legacy.dll
+	      DESTINATION ${RUNTIME_DEST})
+  endif()
   install(CODE "execute_process(COMMAND cmake -E chdir \${CMAKE_INSTALL_PREFIX} tar cvf ${RUNTIME_DEST}.zip --format=zip -- ${RUNTIME_DEST})")
   set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})
