=== img/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 macro(Install_PNG size)
   install(FILES ${S}/xca-icons.iconset/icon_${size}.png
-	DESTINATION ${ICONDIR}/${size}/apps RENAME xca.png
+	DESTINATION ${ICONDIR}/${size}/apps RENAME de.hohnstaedt.xca.png
   )
   install(FILES ${S}/xca-icons.iconset/icon_${size}.png
 	DESTINATION ${ICONDIR}/${size}/mimetypes RENAME x-xca-database.png
