=== misc/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,9 @@
   install(FILES misc/xca.xml
         DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages
   )
+  install(FILES misc/de.hohnstaedt.xca.metainfo.xml
+        DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo
+  )
 elseif(WIN32)
   install(FILES ${TEXT_FILES} ${XCA_TEMPLATES}
 	  DESTINATION ${RUNTIME_DEST}
