=== widgets/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,9 @@
 MW_menu.cpp		X509SuperTreeView.cpp	v3ext.h
 MainWindow.cpp		X509SuperTreeView.h	validity.cpp
 MainWindow.h		XcaApplication.cpp	validity.h
-pkcs12EncBox.h
-pkcs12EncBox.cpp
+pkcs12EncBox.h          XcaDetail.h
+pkcs12EncBox.cpp        XcaDetail.cpp
 )
 
 list(TRANSFORM xca_sources PREPEND ${PROJECT_SOURCE_DIR}/widgets/)
-target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${xca_sources})
+target_sources(xcalib PRIVATE ${xca_sources})
