=== debian/changelog ===
xca (2.6.0-2) unstable; urgency=medium

  * d/control: Add 'or' dependency on libqt5sql5 for backports compat
  * d/clean: Add additional paths for dh_clean to clean out - some files 
    are generated during build time and not in Makefile clean targets, so
    clean it here. Allows double-builds to work. (Closes: #1045831)
  * d/control: Remove libqt5sql5 dependency as it should be included in 
    libqt5sql5{,t64}. (Closes: #1074383) 

 -- Thomas Ward <teward@ubuntu.com>  Fri, 27 Jun 2024 17:13:00 -0400

xca (2.6.0-1) unstable; urgency=medium

  * New upstream release (2.6.0)
  * d/control: Remove constraints unnecessary since Buster:
    - Build-Depends: Drop versioned constraint on dpkg-dev.
    - Build-Depends: Use pkgconf instead of pkg-config; add pkg-config
      as an "OR"'d dependency for systems without pkgconf (allows for 
      easier backport compat)
  * d/control: Update dependencies affected by t64 migration
    (Closes: #1067697)
  * d/source/git-patches: Remove now-obsolete git-patches. 
  * d/copyright: Update copyright stanzas.

 -- Thomas Ward <teward@ubuntu.com>  Fri, 5 Apr 2024 17:14:00 -0400
