=== debian/control ===
--- 
+++ 
@@ -9,9 +9,7 @@
                libssl-dev,
                linuxdoc-tools,
                libltdl-dev,
-               pkg-config,
-               dpkg-dev (>= 1.16.1~),
-               libqt5sql5t64,
+               pkgconf | pkg-config,
                libqt5help5,
                python3-sphinx,
                python3-sphinxcontrib.qthelp,
